---
id: api-onChangeComplete
title: onChangeComplete
---
Pass a function to call once a color change is complete.

```
var React = require('react');
var ColorPicker = require('react-color');

class Component extends React.Component {

  constructor() {
    super();
    this.state = {
      background: '#fff',
    };
    this.handleChangeComplete = this.handleChangeComplete.bind(this);
  }

  handleChangeComplete(color) {
    this.setState({ background: color.hex });
  }

  render() {
    return <ColorPicker onChangeComplete={ this.handleChangeComplete } />;
  }
}
```
